#include "qsimpleserver.h"

QSimpleServer::QSimpleServer(QObject *parent) :
    QTcpServer(parent)
{
    //Запуск сервера на прослушивание на порту 80
    if(listen(QHostAddress::Any, 80)){
        qDebug() << "Listening...";
    }
    else {
        qDebug() << "Error while starting: " << errorString();
    }
}

void QSimpleServer::incomingConnection(int handle)
{
    //Создание объекта сокета
    QTcpSocket* socket = new QTcpSocket();
    //Сопоставление объекта сокета с системным сокетом по дескриптору
    socket->setSocketDescriptor(handle);

    //Соединение сигналов сокета с одноименными слотами
    connect(socket, SIGNAL(readyRead()), this, SLOT(onReadyRead()));
    connect(socket, SIGNAL(disconnected()), this, SLOT(onDisconnected()));
}

void QSimpleServer::onReadyRead()
{
    //Получение указателя на слот, испустивший сигнал
    QTcpSocket* socket = qobject_cast<QTcpSocket*>(sender());
    //Чтение и вывод информации из сокета
    qDebug() << socket->readAll();

    //Генерация ответа сервера
    QString response = "HTTP/1.1 200 OK\r\n\r\n%1";
    //Запись ответа сервера в сокет
    socket->write(response.arg(QTime::currentTime().toString()).toLatin1());
    //Отсоединение сокета
    socket->disconnectFromHost();
}

void QSimpleServer::onDisconnected()
{
    //Получение указателя на слот, испстивший сигнал
    QTcpSocket* socket = qobject_cast<QTcpSocket*>(sender());
    //Закрытие сокета
    socket->close();
    //Метод отсроченного удаления объекта
    socket->deleteLater();
}
